/* /u/bengt/netlib/odepack/Double/dewset.f -- translated by f2c (version of 15 July 1991  13:13:31).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f-c-gnans.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Subroutine */ int ewset_(integer *n, integer *itol, doublereal *rtol, 
	doublereal *atol, doublereal *ycur, doublereal *ewt)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static integer i;

/* lll. optimize */
/* -----------------------------------------------------------------------
 */
/* this subroutine sets the error weight vector ewt according to */
/*     ewt(i) = rtol(i)*abs(ycur(i)) + atol(i),  i = 1,...,n, */
/* with the subscript on rtol and/or atol possibly replaced by 1 above, */

/* depending on the value of itol. */
/* -----------------------------------------------------------------------
 */

    /* Parameter adjustments */
    --ewt;
    --ycur;
    --atol;
    --rtol;

    /* Function Body */
    switch (*itol) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
    }
L10:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L15: */
	ewt[i] = rtol[1] * (d__1 = ycur[i], abs(d__1)) + atol[1];
    }
    return 0;
L20:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L25: */
	ewt[i] = rtol[1] * (d__1 = ycur[i], abs(d__1)) + atol[i];
    }
    return 0;
L30:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L35: */
	ewt[i] = rtol[i] * (d__1 = ycur[i], abs(d__1)) + atol[1];
    }
    return 0;
L40:
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L45: */
	ewt[i] = rtol[i] * (d__1 = ycur[i], abs(d__1)) + atol[i];
    }
    return 0;
/* ----------------------- end of subroutine ewset -----------------------
 */
} /* ewset_ */

#ifdef __cplusplus
	}
#endif
