/* /u/bengt/netlib/odepack/Double/dprepj.f -- translated by f2c (version of 15 July 1991  13:13:31).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f-c-gnans.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Common Block Declarations */

extern struct {
    doublereal rowns[209], ccmax, el0, h, hmin, hmxi, hu, rc, tn, uround;
    integer iownd[14], iowns[6], icf, ierpj, iersl, jcur, jstart, kflag, l, 
	    meth, miter, maxord, maxcor, msbp, mxncf, n, nq, nst, nfe, nje, 
	    nqu;
} ls0001_;

#define ls0001_1 ls0001_

/* Table of constant values */

static integer c__0 = 0;

/* Subroutine */ int prepj_(integer *neq, doublereal *y, doublereal *yh, 
	integer *nyh, doublereal *ewt, doublereal *ftem, doublereal *savf, 
	doublereal *wm, integer *iwm, S_fp f, S_fp jac)
{
    /* System generated locals */
    integer yh_dim1, yh_offset, i__1, i__2, i__3, i__4;
    doublereal d__1, d__2;

    /* Local variables */
    static integer lenp;
    static doublereal srur;
    extern /* Subroutine */ int dgbfa_(doublereal *, integer *, integer *, 
	    integer *, integer *, integer *, integer *), dgefa_(doublereal *, 
	    integer *, integer *, integer *, integer *);
    static integer i, j, mband;
    static doublereal r;
    static integer i1, i2, j1;
    extern doublereal vnorm_(integer *, doublereal *, doublereal *);
    static doublereal r0, di;
    static integer ii, jj, meband, ml, mu;
    static doublereal yi, yj, hl0;
    static integer ml3, np1;
    static doublereal fac;
    static integer mba, ier;
    static doublereal con, yjj;
    static integer meb1;

/* lll. optimize */
/* -----------------------------------------------------------------------
 */
/* prepj is called by stode to compute and process the matrix */
/* p = i - h*el(1)*j , where j is an approximation to the jacobian. */
/* here j is computed by the user-supplied routine jac if */
/* miter = 1 or 4, or by finite differencing if miter = 2, 3, or 5. */
/* if miter = 3, a diagonal approximation to j is used. */
/* j is stored in wm and replaced by p.  if miter .ne. 3, p is then */
/* subjected to lu decomposition in preparation for later solution */
/* of linear systems with p as coefficient matrix. this is done */
/* by dgefa if miter = 1 or 2, and by dgbfa if miter = 4 or 5. */

/* in addition to variables described previously, communication */
/* with prepj uses the following.. */
/* y     = array containing predicted values on entry. */
/* ftem  = work array of length n (acor in stode). */
/* savf  = array containing f evaluated at predicted y. */
/* wm    = real work space for matrices.  on output it contains the */
/*         inverse diagonal matrix if miter = 3 and the lu decomposition 
*/
/*         of p if miter is 1, 2 , 4, or 5. */
/*         storage of matrix elements starts at wm(3). */
/*         wm also contains the following matrix-related data.. */
/*         wm(1) = sqrt(uround), used in numerical jacobian increments. */

/*         wm(2) = h*el0, saved for later use if miter = 3. */
/* iwm   = integer work space containing pivot information, starting at */

/*         iwm(21), if miter is 1, 2, 4, or 5.  iwm also contains band */
/*         parameters ml = iwm(1) and mu = iwm(2) if miter is 4 or 5. */
/* el0   = el(1) (input). */
/* ierpj = output error flag,  = 0 if no trouble, .gt. 0 if */
/*         p matrix found to be singular. */
/* jcur  = output flag = 1 to indicate that the jacobian matrix */
/*         (or approximation) is now current. */
/* this routine also uses the common variables el0, h, tn, uround, */
/* miter, n, nfe, and nje. */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --iwm;
    --wm;
    --savf;
    --ftem;
    --ewt;
    yh_dim1 = *nyh;
    yh_offset = yh_dim1 + 1;
    yh -= yh_offset;
    --y;
    --neq;

    /* Function Body */
    ++ls0001_1.nje;
    ls0001_1.ierpj = 0;
    ls0001_1.jcur = 1;
    hl0 = ls0001_1.h * ls0001_1.el0;
    switch (ls0001_1.miter) {
	case 1:  goto L100;
	case 2:  goto L200;
	case 3:  goto L300;
	case 4:  goto L400;
	case 5:  goto L500;
    }
/* if miter = 1, call jac and multiply by scalar. ----------------------- 
*/
L100:
    lenp = ls0001_1.n * ls0001_1.n;
    i__1 = lenp;
    for (i = 1; i <= i__1; ++i) {
/* L110: */
	wm[i + 2] = 0.;
    }
    (*jac)(&neq[1], &ls0001_1.tn, &y[1], &c__0, &c__0, &wm[3], &ls0001_1.n);
    con = -hl0;
    i__1 = lenp;
    for (i = 1; i <= i__1; ++i) {
/* L120: */
	wm[i + 2] *= con;
    }
    goto L240;
/* if miter = 2, make n calls to f to approximate j. -------------------- 
*/
L200:
    fac = vnorm_(&ls0001_1.n, &savf[1], &ewt[1]);
    r0 = abs(ls0001_1.h) * 1e3 * ls0001_1.uround * (doublereal) ls0001_1.n * 
	    fac;
    if (r0 == 0.) {
	r0 = 1.;
    }
    srur = wm[1];
    j1 = 2;
    i__1 = ls0001_1.n;
    for (j = 1; j <= i__1; ++j) {
	yj = y[j];
/* Computing MAX */
	d__1 = srur * abs(yj), d__2 = r0 / ewt[j];
	r = max(d__1,d__2);
	y[j] += r;
	fac = -hl0 / r;
	(*f)(&neq[1], &ls0001_1.tn, &y[1], &ftem[1]);
	i__2 = ls0001_1.n;
	for (i = 1; i <= i__2; ++i) {
/* L220: */
	    wm[i + j1] = (ftem[i] - savf[i]) * fac;
	}
	y[j] = yj;
	j1 += ls0001_1.n;
/* L230: */
    }
    ls0001_1.nfe += ls0001_1.n;
/* add identity matrix. ------------------------------------------------- 
*/
L240:
    j = 3;
    np1 = ls0001_1.n + 1;
    i__1 = ls0001_1.n;
    for (i = 1; i <= i__1; ++i) {
	wm[j] += 1.;
/* L250: */
	j += np1;
    }
/* do lu decomposition on p. -------------------------------------------- 
*/
    dgefa_(&wm[3], &ls0001_1.n, &ls0001_1.n, &iwm[21], &ier);
    if (ier != 0) {
	ls0001_1.ierpj = 1;
    }
    return 0;
/* if miter = 3, construct a diagonal approximation to j and p. --------- 
*/
L300:
    wm[2] = hl0;
    r = ls0001_1.el0 * .1;
    i__1 = ls0001_1.n;
    for (i = 1; i <= i__1; ++i) {
/* L310: */
	y[i] += r * (ls0001_1.h * savf[i] - yh[i + (yh_dim1 << 1)]);
    }
    (*f)(&neq[1], &ls0001_1.tn, &y[1], &wm[3]);
    ++ls0001_1.nfe;
    i__1 = ls0001_1.n;
    for (i = 1; i <= i__1; ++i) {
	r0 = ls0001_1.h * savf[i] - yh[i + (yh_dim1 << 1)];
	di = r0 * .1 - ls0001_1.h * (wm[i + 2] - savf[i]);
	wm[i + 2] = 1.;
	if (abs(r0) < ls0001_1.uround / ewt[i]) {
	    goto L320;
	}
	if (abs(di) == 0.) {
	    goto L330;
	}
	wm[i + 2] = r0 * .1 / di;
L320:
	;
    }
    return 0;
L330:
    ls0001_1.ierpj = 1;
    return 0;
/* if miter = 4, call jac and multiply by scalar. ----------------------- 
*/
L400:
    ml = iwm[1];
    mu = iwm[2];
    ml3 = ml + 3;
    mband = ml + mu + 1;
    meband = mband + ml;
    lenp = meband * ls0001_1.n;
    i__1 = lenp;
    for (i = 1; i <= i__1; ++i) {
/* L410: */
	wm[i + 2] = 0.;
    }
    (*jac)(&neq[1], &ls0001_1.tn, &y[1], &ml, &mu, &wm[ml3], &meband);
    con = -hl0;
    i__1 = lenp;
    for (i = 1; i <= i__1; ++i) {
/* L420: */
	wm[i + 2] *= con;
    }
    goto L570;
/* if miter = 5, make mband calls to f to approximate j. ---------------- 
*/
L500:
    ml = iwm[1];
    mu = iwm[2];
    mband = ml + mu + 1;
    mba = min(mband,ls0001_1.n);
    meband = mband + ml;
    meb1 = meband - 1;
    srur = wm[1];
    fac = vnorm_(&ls0001_1.n, &savf[1], &ewt[1]);
    r0 = abs(ls0001_1.h) * 1e3 * ls0001_1.uround * (doublereal) ls0001_1.n * 
	    fac;
    if (r0 == 0.) {
	r0 = 1.;
    }
    i__1 = mba;
    for (j = 1; j <= i__1; ++j) {
	i__2 = ls0001_1.n;
	i__3 = mband;
	for (i = j; i__3 < 0 ? i >= i__2 : i <= i__2; i += i__3) {
	    yi = y[i];
/* Computing MAX */
	    d__1 = srur * abs(yi), d__2 = r0 / ewt[i];
	    r = max(d__1,d__2);
/* L530: */
	    y[i] += r;
	}
	(*f)(&neq[1], &ls0001_1.tn, &y[1], &ftem[1]);
	i__3 = ls0001_1.n;
	i__2 = mband;
	for (jj = j; i__2 < 0 ? jj >= i__3 : jj <= i__3; jj += i__2) {
	    y[jj] = yh[jj + yh_dim1];
	    yjj = y[jj];
/* Computing MAX */
	    d__1 = srur * abs(yjj), d__2 = r0 / ewt[jj];
	    r = max(d__1,d__2);
	    fac = -hl0 / r;
/* Computing MAX */
	    i__4 = jj - mu;
	    i1 = max(i__4,1);
/* Computing MIN */
	    i__4 = jj + ml;
	    i2 = min(i__4,ls0001_1.n);
	    ii = jj * meb1 - ml + 2;
	    i__4 = i2;
	    for (i = i1; i <= i__4; ++i) {
/* L540: */
		wm[ii + i] = (ftem[i] - savf[i]) * fac;
	    }
/* L550: */
	}
/* L560: */
    }
    ls0001_1.nfe += mba;
/* add identity matrix. ------------------------------------------------- 
*/
L570:
    ii = mband + 2;
    i__1 = ls0001_1.n;
    for (i = 1; i <= i__1; ++i) {
	wm[ii] += 1.;
/* L580: */
	ii += meband;
    }
/* do lu decomposition of p. -------------------------------------------- 
*/
    dgbfa_(&wm[3], &meband, &ls0001_1.n, &ml, &mu, &iwm[21], &ier);
    if (ier != 0) {
	ls0001_1.ierpj = 1;
    }
    return 0;
/* ----------------------- end of subroutine prepj -----------------------
 */
} /* prepj_ */

#ifdef __cplusplus
	}
#endif
