/* -*- c++ -*-
Copyright  1992, 1993 Bengt Mrtensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: DIntegrator.h,v 1.3 1994/08/24 09:58:06 bengt Exp $

#ifndef _DIntegrator_h
#define _DIntegrator_h

#if __GNUC__
#pragma interface
#endif

#include "Integrator.h"

class DiscreteIntegrator : public Integrator {
 public:
  const char *name() const;
  const char * documentation() const;
  bool loop(bool);
 private:
  bool initialize_integrator();
  virtual void store_stuff();
  virtual bool finished() const;
  bool more_to_do();
};

#endif
