// $Id: Resource.h,v 1.2 1994/02/14 22:24:02 bengt Exp $

#ifdef __GNUG__
#pragma interface
#endif

#define WORKING_MEMORY_GAUGE

#include <sys/resource.h>
#ifdef USE_PRUSAGE
#include <sys/procfs.h>
#endif
#ifdef USE_GETRUSAGE
#define WORKING_MEMORY_GAUGE
#include <sys/time.h>
#endif

class Resource {
 private:
#ifdef USE_PRUSAGE
  int fd;
  char proc[MAXSTRINGSIZE];
  prusage_t prusage;
#endif
#ifdef USE_GETRUSAGE
  static unsigned int pages2kBytes;
  struct rusage Rusage;
#endif
 public:
  Resource();
  double user_seconds() const;
  double system_seconds() const;
  unsigned int kilobytes() const;
  ~Resource();
};
