/* /u/bengt/netlib/odepack/Double/dvnorm.f -- translated by f2c (version of 15 July 1991  13:13:31).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)
*/

#include "f-c-gnans.h"

#ifdef __cplusplus
extern "C" {
#endif

doublereal vnorm_(integer *n, doublereal *v, doublereal *w)
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val, d__1;

    /* Builtin functions */
#if 0
    double sqrt(doublereal);
#endif

    /* Local variables */
    static integer i;
    static doublereal sum;

/* lll. optimize */
/* -----------------------------------------------------------------------
 */
/* this function routine computes the weighted root-mean-square norm */
/* of the vector of length n contained in the array v, with weights */
/* contained in the array w of length n.. */
/*   vnorm = sqrt( (1/n) * sum( v(i)*w(i) )**2 ) */
/* -----------------------------------------------------------------------
 */
    /* Parameter adjustments */
    --w;
    --v;

    /* Function Body */
    sum = 0.;
    i__1 = *n;
    for (i = 1; i <= i__1; ++i) {
/* L10: */
/* Computing 2nd power */
	d__1 = v[i] * w[i];
	sum += d__1 * d__1;
    }
    ret_val = sqrt(sum / (doublereal) (*n));
    return ret_val;
/* ----------------------- end of function vnorm -------------------------
 */
} /* vnorm_ */

#ifdef __cplusplus
	}
#endif
