/* -*- c++ -*-
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Lsode.h,v 1.5 1994/08/24 09:58:06 bengt Exp $

#ifndef _Lsode_h
#define _Lsode_h

#ifdef __GNUG__
#pragma interface
#endif

#include "HIntegrator.h"

class LsodeIntegrator : public HindmarshIntegrator {
public:
  const char *documentation() const;

protected:
  bool call_integrator();

private:
  bool make_setup(int flag);
};

#endif
